
function DrawArmourWin()

	local tempWidth = 640;
	local tempHeight = 500;

	-- Set initial view
	local MYCLASSNAME = GetClassName(MYCHAR:GetClass()); -- E.g. Minstrel
	local MYCLASSID = 1;

	for k,v in pairs(_CLASSES) do
		if v.ENGLISH == MYCLASSNAME then
			MYCLASSID = k;
			break;
		end
	end

	ARMOURY_SELCLASSID = MYCLASSID;

	-- Main Parent window to hold all the elements
	wArmourWinParent = Turbine.UI.Lotro.Window();
	wArmourWinParent:SetSize(tempWidth,tempHeight);
	wArmourWinParent:SetPosition(SETTINGS.ARMOURWIN.X,SETTINGS.ARMOURWIN.Y);
	wArmourWinParent:SetText("Hytbold Armoury");
	wArmourWinParent:SetVisible(SETTINGS.ARMOURWIN.VISIBLE);

	Onscreen(wArmourWinParent); -- Makes sure the window is still onscreen (perhaps user changed resolution since last playing)

	wArmourWinBack = Turbine.UI.Control();
	wArmourWinBack:SetParent(wArmourWinParent);
	wArmourWinBack:SetSize(638,500);
	wArmourWinBack:SetPosition(0,-4);
	wArmourWinBack:SetBackground(_IMAGES.ARMOURBACK);
	wArmourWinBack:SetMouseVisible(false);
	wArmourWinBack:SetBlendMode(4);

	-- Class buttons container
	ctClassButtons = Turbine.UI.Control();
	ctClassButtons:SetParent(wArmourWinParent);
	ctClassButtons:SetSize(616,95);
	ctClassButtons:SetPosition((tempWidth/2)-(ctClassButtons:GetWidth()/2),35);

	-- fill container with buttons.
	btnClass = {};
	iconClass = {};

	local CURLEFT = 0;


	for i=1, table.getn(_CLASSES) do

		btnClass[i] = Turbine.UI.Control();
		btnClass[i]:SetParent(ctClassButtons);
		btnClass[i]:SetSize(64,64);
		btnClass[i]:SetPosition(CURLEFT,30);
		btnClass[i]:SetBlendMode(4);

		--Debug(i .. " " .. ARMOURY_SELCLASSID);

		if i == ARMOURY_SELCLASSID then
			btnClass[i]:SetBackground(_IMAGES.CLASSBUTTON_OVER);
		else
			btnClass[i]:SetBackground(_IMAGES.CLASSBUTTON_NORMAL);
		end

		btnClass[i].MouseClick = function ()
			ARMOURY_SELCLASSID = i;
			ARMOURY_SELSETNAME = "";

			for k,v in pairs (btnClass) do
				if k ~= i then
					btnClass[k]:SetBackground(_IMAGES.CLASSBUTTON_NORMAL);
				end
			end

			SetClass(i);
		end

		btnClass[i].MouseEnter = function ()
			btnClass[i]:SetBackground(_IMAGES.CLASSBUTTON_OVER);
		end

		btnClass[i].MouseLeave = function ()
			if ARMOURY_SELCLASSID ~= i then
				btnClass[i]:SetBackground(_IMAGES.CLASSBUTTON_NORMAL);
			end
		end

		iconClass[i] = Turbine.UI.Control();
		iconClass[i]:SetParent(btnClass[i]);
		iconClass[i]:SetSize(40,40);
		iconClass[i]:SetPosition(12,12);
		iconClass[i]:SetBackground(_IMAGES.CLASSES[i]);
		iconClass[i]:SetMouseVisible(false);
		iconClass[i]:SetBlendMode(4);

		CURLEFT = CURLEFT + btnClass[i]:GetWidth() + 5;

	end

	lblClassName = Turbine.UI.Label();
	lblClassName:SetParent(ctClassButtons);
	lblClassName:SetSize(ctClassButtons:GetWidth(),20)
	lblClassName:SetPosition(0,0);
	lblClassName:SetFont(TrajanPro16);
	lblClassName:SetForeColor(Turbine.UI.Color.Beige);
	lblClassName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblClassName:SetOutlineColor(Turbine.UI.Color(0.1,0.1,0.1));
	lblClassName:SetFontStyle(Turbine.UI.FontStyle.Outline);

	----------------------------------------------------------------------------------

	-- ListBox for displaying the set infos..

	lstArmour = Turbine.UI.ListBox();
	lstArmour:SetParent(wArmourWinParent);
	lstArmour:SetSize(tempWidth-50,tempHeight-190);
	lstArmour:SetPosition(25,180);
	--lstArmour:SetBackColor(Turbine.UI.Color.Red);

	sblstArmour = Turbine.UI.Lotro.ScrollBar();
	sblstArmour:SetParent(wArmourWinParent);
	sblstArmour:SetSize(8,lstArmour:GetHeight());
	sblstArmour:SetPosition(lstArmour:GetLeft()+lstArmour:GetWidth()+2,lstArmour:GetTop());
	sblstArmour:SetOrientation(Turbine.UI.Orientation.Vertical);
	sblstArmour:SetZOrder(200000);
	sblstArmour:SetVisible(false);

    lstArmour:SetVerticalScrollBar(sblstArmour);


	SetClass(MYCLASSID);

	-- Window events
	wArmourWinParent.Closing = function()
		SETTINGS.ARMOURWIN.VISIBLE = false;
	end

	wArmourWinParent.PositionChanged = function()
		SETTINGS.ARMOURWIN.X = wArmourWinParent:GetLeft();
		SETTINGS.ARMOURWIN.Y = wArmourWinParent:GetTop();
	end

	wArmourWinParent.VisibleChanged = function()
		if wArmourWinParent:IsVisible() then
			wArmourWinParent:Activate();
			SetClass(ARMOURY_SELCLASSID);
		end
	end

end


function SetClass(CLASSID)

	local CLASSNAME = _CLASSES[CLASSID][SETTINGS.LANGUAGE];
	lblClassName:SetText(CLASSNAME);

	-- Create the set dropdown
	if ddClassSets ~= nil then ddClassSets:Delete() end;

	local _CLASSSETS = {};
	local _CLASSSETNAMES = {};

	for k,v in pairs (_SETS) do
		if v.CLASS == CLASSID then
			table.insert(_CLASSSETS,k);
			table.insert(_CLASSSETNAMES,v.NAME[SETTINGS.LANGUAGE]);
		end
	end

	if ARMOURY_SELSETNAME ~= "" then
		ddClassSets = DropDown.Create(_CLASSSETNAMES,ARMOURY_SELSETNAME);
	else
		ddClassSets = DropDown.Create(_CLASSSETNAMES);
	end

	ddClassSets:SetParent(wArmourWinParent);
	ddClassSets:ApplyWidth(300);
	ddClassSets:SetPosition((wArmourWinParent:GetWidth()/2)-150,ctClassButtons:GetTop()+ctClassButtons:GetHeight()+15);

	ddClassSets.ItemChanged = function ()
		ARMOURY_SELSETNAME = ddClassSets:GetText();
		SetArmourSet(ARMOURY_SELSETNAME);
	end

	ARMOURY_SELSETNAME = ddClassSets:GetText();
	SetArmourSet(ARMOURY_SELSETNAME);

end


function SetArmourSet(SETNAME)

	if SETNAME == nil then return end;

	-- Update the list box with the set info.
	lstArmour:ClearItems();

	local _CURSET = _SETS[GetSetID(SETNAME)];
	table.sort(_CURSET.PIECES);

	for k,v in pairs (_CURSET.PIECES) do

		local _ARMOURINFO = _ARMOUR[v];
		local DEEDID,QUESTID = GetArmourPrereq(v);
		local _QUESTINFO = _QUESTSTRINGS[DEEDID][QUESTID];

		--local EXAMINESTRING = "<Examine:IIDDID:0x0000000000000000:" .. _ARMOURINFO.ID .. ">[" .. _ARMOURINFO.NAME[SETTINGS.LANGUAGE] .. "]<\Examine> ";

		local ITEMHOLDER = Turbine.UI.Control();
		ITEMHOLDER:SetSize(lstArmour:GetWidth(),50);

		local cItemInspect = Turbine.UI.Lotro.Quickslot();
		cItemInspect:SetParent(ITEMHOLDER);
		cItemInspect:SetSize(36,36);
		cItemInspect:SetPosition(0,2);
		cItemInspect:SetAllowDrop(false);
		cItemInspect:SetUseOnRightClick(false);

		cItemInspect:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item, "0x0,0x" .. TO_HEX(_ARMOURINFO.ID)));


		local lblItemName = Turbine.UI.Label();
		lblItemName:SetParent(ITEMHOLDER);
		lblItemName:SetSize(400,20)
		lblItemName:SetPosition(45,0);
		lblItemName:SetFont(TrajanPro16);
		--lblItemName:SetBackColor(Turbine.UI.Color.Red);
		lblItemName:SetForeColor(Turbine.UI.Color.Cyan);
		lblItemName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		lblItemName:SetText(_ARMOURINFO.NAME[SETTINGS.LANGUAGE]);


		local QUESTSTRING = "";

		-- Check if needed quest is completed.
		if _CHARDATA[SELECTEDCHARACTER]["HYTBOLD"][DEEDID][QUESTID] then
			QUESTSTRING = "<rgb=#00FF00>" .. _QUESTINFO.STRINGS[SETTINGS.LANGUAGE] .. "</rgb>";
		else
			QUESTSTRING = _QUESTINFO.STRINGS[SETTINGS.LANGUAGE];
		end


		local lblQuestName	= Turbine.UI.Label();
		lblQuestName:SetParent(ITEMHOLDER);
		lblQuestName:SetSize(400,20)
		lblQuestName:SetPosition(45,20);
		lblQuestName:SetFont(Verdana14);
		lblQuestName:SetMarkupEnabled(true);
		--lblQuestName:SetBackColor(Turbine.UI.Color.Red);
		lblQuestName:SetForeColor(Turbine.UI.Color.Beige);
		lblQuestName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		lblQuestName:SetText(QUESTSTRING);


		-- Quest req tooltip
		local ToolTipString = QUESTSTRING .. "\n\n" .. _LANG.NOREQ[SETTINGS.LANGUAGE];

		if _QUESTINFO.PREREQ ~= nil then
			ToolTipString = QUESTSTRING .. "\n\n" .. _LANG.REQUIRES[SETTINGS.LANGUAGE] .. ":\n";
			for k,v in pairs (_QUESTINFO.PREREQ) do

				-- Prereq completed?
				local PRECOMPLETED = _CHARDATA[SELECTEDCHARACTER]["HYTBOLD"][DEEDID][v];

				if PRECOMPLETED == true then
					ToolTipString = ToolTipString .. "<rgb=#00FF00>" .. _QUESTSTRINGS[DEEDID][v]["STRINGS"][SETTINGS.LANGUAGE] .. "</rgb>\n";
				else
					ToolTipString = ToolTipString .. _QUESTSTRINGS[DEEDID][v]["STRINGS"][SETTINGS.LANGUAGE] .. "\n";
				end
			end
		end

		local tmpToolTip = Tooltip.Create(lblQuestName,ToolTipString);


		local imgQuestToken = Turbine.UI.Control();
		imgQuestToken:SetParent(ITEMHOLDER);
		imgQuestToken:SetSize(32,32);
		imgQuestToken:SetPosition(ITEMHOLDER:GetWidth()-42,5);
		imgQuestToken:SetBlendMode(4);
		imgQuestToken:SetBackground(_IMAGES.HYTBOLDTOKEN);

		local lblQuestTokens = Turbine.UI.Label();
		lblQuestTokens:SetParent(imgQuestToken);
		lblQuestTokens:SetSize(28,18);
		lblQuestTokens:SetPosition(imgQuestToken:GetWidth()-32,15);
		lblQuestTokens:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
		lblQuestTokens:SetFont(TrajanPro14);
		lblQuestTokens:SetForeColor(Turbine.UI.Color.Khaki);
		lblQuestTokens:SetOutlineColor(Turbine.UI.Color.Black);
		lblQuestTokens:SetMouseVisible(false);
		lblQuestTokens:SetFontStyle(Turbine.UI.FontStyle.Outline);
		lblQuestTokens:SetText(_ARMOURINFO.TOKENS);


		lstArmour:AddItem(ITEMHOLDER);

	end

end


